>From b508b13188307a09f57e7243cacafb6122c001f0 Mon Sep 17 00:00:00 2001
From: Manol Manolov <man40dev@gmail.com>
Date: Sat, 17 Jul 2010 22:43:51 -0400
Subject: [PATCH 1/2] Add support for Clear QAM

Clear QAM is US standard for HD cable TV. Also improoved BDA access in Windows 7This is the first time i commit to VLC. I'm sorry if I didn't do something as I should. Please Contact me if any questions. man40dev -at- gmail.com.
Manol Manolov.
---
 modules/access/bda/bda.c        |   13 +++-
 modules/access/bda/bda.h        |    1 +
 modules/access/bda/bdadefs.h    |   35 +++++++++
 modules/access/bda/bdagraph.cpp |  154 +++++++++++++++++++++++++++++++++------
 modules/access/bda/bdagraph.h   |    1 +
 5 files changed, 179 insertions(+), 25 deletions(-)

diff --git a/modules/access/bda/bda.c b/modules/access/bda/bda.c
index 24a0d6f..3a18cc4 100644
--- a/modules/access/bda/bda.c
+++ b/modules/access/bda/bda.c
@@ -129,6 +129,10 @@ static const char *const ppsz_mod_text[] = {
 #define PHYSICAL_CHANNEL_TEXT N_("ATSC Physical Channel")
 #define PHYSICAL_CHANNEL_LONGTEXT N_("ATSC Physical Channel")
 
+/* Clear QAM */
+#define PROGRAM_NUMBER_TEXT N_("Clear QAM Program")
+#define PROGRAM_NUMBER_LONGTEXT N_("Clear QAM has more than one program on a particular frequeny/physical channel")
+
 /* Terrestrial */
 #define CODE_RATE_HP_TEXT N_("FEC rate")
 #define CODE_RATE_HP_LONGTEXT N_("FEC rate includes " \
@@ -297,7 +301,8 @@ vlc_module_begin ()
                   "dvb-s", "dvbs", "qpsk", "satellite",     /* Satellite */
                   "dvb-c", "dvbc", "qam", "cable",          /* Cable */
                   "dvbt", "dvb-t", "ofdm", "terrestrial",   /* Terrestrial */
-                  "atsc", "usdigital" )                     /* Atsc */
+                  "atsc", "usdigital",                      /* Atsc */
+                  "cqam"  )                                 /* Clear QAM */
 
     set_callbacks( Open, Close )
 vlc_module_end ()
@@ -394,6 +399,10 @@ static int Open( vlc_object_t *p_this )
     {
         i_ret = dvb_SubmitATSCTuneRequest( p_access );
     }
+    if( strncmp( p_access->psz_access, "cqam", 4 ) == 0 )
+    {
+        i_ret = dvb_SubmitCQAMTuneRequest( p_access );
+    }
     if( !strcmp( p_access->psz_access, "dvb" ) )
     {
         /* Try to auto detect */
@@ -405,6 +414,8 @@ static int Open( vlc_object_t *p_this )
             i_ret = dvb_SubmitDVBTTuneRequest( p_access );
         if( i_ret )
             i_ret = dvb_SubmitATSCTuneRequest( p_access );
+        if( i_ret )
+            i_ret = dvb_SubmitCQAMTuneRequest( p_access );
     }
 
     if( !i_ret )
diff --git a/modules/access/bda/bda.h b/modules/access/bda/bda.h
index b043f64..609cf69 100644
--- a/modules/access/bda/bda.h
+++ b/modules/access/bda/bda.h
@@ -63,6 +63,7 @@ typedef struct BDAGraph BDAGraph;
 
 void dvb_newBDAGraph( access_t* p_access );
 void dvb_deleteBDAGraph( access_t* p_access );
+int dvb_SubmitCQAMTuneRequest( access_t* p_access );
 int dvb_SubmitATSCTuneRequest( access_t* p_access );
 int dvb_SubmitDVBTTuneRequest( access_t* p_access );
 int dvb_SubmitDVBCTuneRequest( access_t* p_access );
diff --git a/modules/access/bda/bdadefs.h b/modules/access/bda/bdadefs.h
index c9fe2a8..1b7b834 100644
--- a/modules/access/bda/bdadefs.h
+++ b/modules/access/bda/bdadefs.h
@@ -20,6 +20,8 @@
  * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
  *****************************************************************************/
 
+class ICQAMChannelTuneRequest;
+class ICQAMLocator;
 class IATSCChannelTuneRequest;
 class IATSCLocator;
 class IBDA_DeviceControl;
@@ -391,6 +393,15 @@ public:
     virtual HRESULT __stdcall put_MinorChannel( long l_minor_channel )=0;
 };
 
+class ICQAMChannelTuneRequest : public IATSCChannelTuneRequest
+{
+public:
+    virtual HRESULT __stdcall get_MajorChannel( long* pl_major_channel )=0;
+    virtual HRESULT __stdcall put_MajorChannel( long l_major_channel )=0;
+    virtual HRESULT __stdcall get_SourceID( long* pl_source_id )=0;
+    virtual HRESULT __stdcall put_SourceID( long l_source_id )=0;
+};
+
 class IDVBTuneRequest : public ITuneRequest
 {
 public:
@@ -435,6 +446,13 @@ public:
     virtual HRESULT __stdcall put_TSID( long l_tsid )=0;
 };
 
+class ICQAMLocator : public IATSCLocator
+{
+public:
+    virtual HRESULT __stdcall get_ProgramNumber( long* pl_prog_number )=0;
+    virtual HRESULT __stdcall put_ProgramNumber( long l_prog_number )=0;
+};
+
 class IDVBCLocator : public ILocator
 {
 public:
@@ -914,6 +932,23 @@ public:
 };
 
 extern "C" {
+/* Following GUIDs are for the new windows 7 interfaces  */
+/* windows 7 universal provider applies to all networks */
+const GUID CLSID_NetworkProvider =
+    {0xB2F3A67C,0x29DA,0x4C78,{0x88,0x31,0x09,0x1E,0xD5,0x09,0xA4,0x75}};
+
+/* Win 7 - Digital Cable - North America Clear QAM */
+const GUID CLSID_DigitalCableTuningSpace =
+    {0xD9BB4CEE,0xB87A,0x47F1,{0xAC,0xF1,0xB0,0x8D,0x9C,0x78,0x13,0xFC}};
+const GUID CLSID_DigitalCableLocator =
+    {0x03C06416,0xD127,0x407A,{0xAB,0x4C,0xFD,0xD2,0x79,0xAB,0xBE,0x5D}};
+const GUID CLSID_DigitalCableNetwork =
+    {0x143827AB,0xF77B,0x498d,{0x81,0xCA,0x5A,0x00,0x7A,0xEC,0x28,0xBF}};
+const GUID IID_IDigitalCableTuneRequest =
+    {0xBAD7753B,0x6B37,0x4810,{0xAE,0x57,0x3C,0xE0,0xC4,0xA9,0xE6,0xCB}};
+const GUID IID_IDigitalCableLocator =
+    {0x48F66A11,0x171A,0x419A,{0x95,0x25,0xBE,0xEE,0xCD,0x51,0x58,0x4C}};
+
 extern const GUID CLSID_ATSCLocator;
 extern const GUID CLSID_ATSCNetworkProvider;
 extern const GUID CLSID_ATSCTuningSpace;
diff --git a/modules/access/bda/bdagraph.cpp b/modules/access/bda/bdagraph.cpp
index 1a41bb0..e61f680 100644
--- a/modules/access/bda/bdagraph.cpp
+++ b/modules/access/bda/bdagraph.cpp
@@ -41,6 +41,13 @@ extern "C" {
         delete p_access->p_sys->p_bda_module;
     };
 
+    int dvb_SubmitCQAMTuneRequest( access_t* p_access )
+    {
+        if( p_access->p_sys->p_bda_module )
+            return p_access->p_sys->p_bda_module->SubmitCQAMTuneRequest();
+        return VLC_EGENERIC;
+    };
+
     int dvb_SubmitATSCTuneRequest( access_t* p_access )
     {
         if( p_access->p_sys->p_bda_module )
@@ -158,6 +165,102 @@ BDAGraph::~BDAGraph()
 }
 
 /*****************************************************************************
+* Submit an Clear QAM Tune Request (US Cable Shit)
+*****************************************************************************/
+int BDAGraph::SubmitCQAMTuneRequest()
+{
+    HRESULT hr = S_OK;
+    class localComPtr
+    {
+        public:
+        ICQAMChannelTuneRequest* p_cqam_tune_request;
+        ICQAMLocator* p_cqam_locator;
+        localComPtr(): p_cqam_tune_request(NULL), p_cqam_locator(NULL) {};
+        ~localComPtr()
+        {
+            if( p_cqam_tune_request )
+                p_cqam_tune_request->Release();
+            if( p_cqam_locator )
+                p_cqam_locator->Release();
+        }
+    } l;
+    long l_minor_channel, l_physical_channel;
+    long l_program_number, l_frequency;
+
+    l_physical_channel = var_GetInteger( p_access, "dvb-physical-channel" );
+    l_minor_channel    = var_GetInteger( p_access, "dvb-minor-channel" );
+    l_frequency        = var_GetInteger( p_access, "dvb-frequency" );
+
+    guid_network_type = CLSID_DigitalCableNetwork;
+    hr = CreateTuneRequest();
+    if( FAILED( hr ) )
+    {
+        msg_Warn( p_access, "SubmitCQAMTuneRequest: "\
+            "Cannot create Tuning Space: hr=0x%8lx", hr );
+        return VLC_EGENERIC;
+    }
+
+    hr = p_tune_request->QueryInterface( IID_IDigitalCableTuneRequest,
+        (void**)&l.p_cqam_tune_request );
+    if( FAILED( hr ) )
+    {
+        msg_Warn( p_access, "SubmitCQAMTuneRequest: "\
+            "Cannot QI for IDigitalCableTuneRequest: hr=0x%8lx", hr );
+        return VLC_EGENERIC;
+    }
+    hr = ::CoCreateInstance( CLSID_DigitalCableLocator, 0, CLSCTX_INPROC,
+                             IID_IDigitalCableLocator, (void**)&l.p_cqam_locator );
+    if( FAILED( hr ) )
+    {
+        msg_Warn( p_access, "SubmitCQAMTuneRequest: "\
+            "Cannot create the CQAM locator: hr=0x%8lx", hr );
+        return VLC_EGENERIC;
+    }
+
+    hr = S_OK;
+    if( SUCCEEDED( hr ) && l_physical_channel > 0 )
+        hr = l.p_cqam_locator->put_PhysicalChannel( l_physical_channel );
+    if( SUCCEEDED( hr ) && l_frequency > 0 )
+        hr = l.p_cqam_locator->put_CarrierFrequency( l_frequency );
+    if( SUCCEEDED( hr ) && l_minor_channel > 0 )
+        hr = l.p_cqam_tune_request->put_MinorChannel( l_minor_channel );
+    if( SUCCEEDED( hr ) && l_program_number > 0 )
+        hr = l.p_cqam_locator->put_ProgramNumber( l_program_number );
+    if( FAILED( hr ) )
+    {
+        msg_Warn( p_access, "SubmitCQAMTuneRequest: "\
+            "Cannot set tuning parameters: hr=0x%8lx", hr );
+        return VLC_EGENERIC;
+    }
+
+    hr = p_tune_request->put_Locator( l.p_cqam_locator );
+    if( FAILED( hr ) )
+    {
+        msg_Warn( p_access, "SubmitCQAMTuneRequest: "\
+            "Cannot put the locator: hr=0x%8lx", hr );
+        return VLC_EGENERIC;
+    }
+
+    /* Build and Run the Graph. If a Tuner device is in use the graph will
+     * fail to run. Repeated calls to build will check successive tuner
+     * devices */
+    do
+    {
+        hr = Build();
+        if( FAILED( hr ) )
+        {
+            msg_Warn( p_access, "SubmitCQAMTuneRequest: "\
+                "Cannot Build the Graph: hr=0x%8lx", hr );
+            return VLC_EGENERIC;
+        }
+        hr = Start();
+    }
+    while( hr != S_OK );
+
+    return VLC_SUCCESS;
+}
+
+/*****************************************************************************
 * Submit an ATSC Tune Request
 *****************************************************************************/
 int BDAGraph::SubmitATSCTuneRequest()
@@ -1048,6 +1151,8 @@ HRESULT BDAGraph::CreateTuneRequest()
     VARIANT var_id;
     CLSID cls_tuning_space;
 
+    if( IsEqualCLSID( guid_network_type, CLSID_DigitalCableNetwork ) )
+        cls_tuning_space = CLSID_DigitalCableTuningSpace;
     if( IsEqualCLSID( guid_network_type, CLSID_ATSCNetworkProvider ) )
         cls_tuning_space = CLSID_ATSCTuningSpace;
     if( IsEqualCLSID( guid_network_type, CLSID_DVBTNetworkProvider ) )
@@ -1205,7 +1310,7 @@ HRESULT BDAGraph::Build()
 
     /* First filter in the graph is the Network Provider and
      * its Scanning Tuner which takes the Tune Request*/
-    hr = ::CoCreateInstance( guid_network_type, NULL, CLSCTX_INPROC_SERVER,
+    hr = ::CoCreateInstance( CLSID_NetworkProvider, NULL, CLSCTX_INPROC_SERVER,
         IID_IBaseFilter, (void**)&p_network_provider);
     if( FAILED( hr ) )
     {
@@ -1221,29 +1326,6 @@ HRESULT BDAGraph::Build()
         return hr;
     }
 
-    hr = p_network_provider->QueryInterface( IID_IScanningTuner,
-        (void**)&p_scanning_tuner );
-    if( FAILED( hr ) )
-    {
-        msg_Warn( p_access, "Build: "\
-            "Cannot QI Network Provider for Scanning Tuner: hr=0x%8lx", hr );
-        return hr;
-    }
-
-    hr = p_scanning_tuner->Validate( p_tune_request );
-    if( FAILED( hr ) )
-    {
-        msg_Warn( p_access, "Build: "\
-            "Tune Request is invalid: hr=0x%8lx", hr );
-        return hr;
-    }
-    hr = p_scanning_tuner->put_TuneRequest( p_tune_request );
-    if( FAILED( hr ) )
-    {
-        msg_Warn( p_access, "Build: "\
-            "Cannot submit the tune request: hr=0x%8lx", hr );
-        return hr;
-    }
 
     /* Add the Network Tuner to the Network Provider. On subsequent calls,
      * l_tuner_used will cause a different tuner to be selected
@@ -1410,6 +1492,30 @@ HRESULT BDAGraph::Build()
         return hr;
     }
 
+    hr = p_network_provider->QueryInterface( IID_IScanningTuner,
+        (void**)&p_scanning_tuner );
+    if( FAILED( hr ) )
+    {
+        msg_Warn( p_access, "Build: "\
+            "Cannot QI Network Provider for Scanning Tuner: hr=0x%8lx", hr );
+        return hr;
+    }
+
+    hr = p_scanning_tuner->Validate( p_tune_request );
+    if( FAILED( hr ) )
+    {
+        msg_Warn( p_access, "Build: "\
+            "Tune Request is invalid: hr=0x%8lx", hr );
+        //return hr; it is not nesessary to validate. Validate fails, but the request is successfully accepted
+    }
+    hr = p_scanning_tuner->put_TuneRequest( p_tune_request );
+    if( FAILED( hr ) )
+    {
+        msg_Warn( p_access, "Build: "\
+            "Cannot submit the tune request: hr=0x%8lx", hr );
+        return hr;
+    }
+
     hr = Register();
     if( FAILED( hr ) )
     {
diff --git a/modules/access/bda/bdagraph.h b/modules/access/bda/bdagraph.h
index d6c7e2f..3b1b50d 100644
--- a/modules/access/bda/bdagraph.h
+++ b/modules/access/bda/bdagraph.h
@@ -78,6 +78,7 @@ public:
     virtual ~BDAGraph();
 
     /* */
+    int SubmitCQAMTuneRequest();
     int SubmitATSCTuneRequest();
     int SubmitDVBTTuneRequest();
     int SubmitDVBCTuneRequest();
-- 
1.7.0.2.msysgit.0

